package org.joget.pbuilder;

import java.util.ArrayList;
import java.util.Collection;
import org.joget.pbuilder.api.PageWidget;
import org.joget.pbuilder.lib.HtmlPageWidget;
import org.joget.pbuilder.lib.Row;
import org.joget.pbuilder.lib.Column;
import org.joget.pbuilder.lib.PageUserviewMenu;
import org.joget.plugin.base.CustomPluginInterface;
import org.joget.plugin.base.PluginManager;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceRegistration;

public class Activator implements BundleActivator {

    protected Collection<ServiceRegistration> registrationList;

    @Override
    public void start(BundleContext context) {
        registrationList = new ArrayList<ServiceRegistration>();
        
        //Register custom plugin interface to extends the builder
        PluginManager.registerCustomPluginInterface(new CustomPluginInterface(PageWidget.class, "pageBuilder.pageWidget", PageBuilder.MESSAGE_PATH));
        
        //Register plugin here
        registrationList.add(context.registerService(PageBuilder.class.getName(), new PageBuilder(), null));
        registrationList.add(context.registerService(Row.class.getName(), new Row(), null));
        registrationList.add(context.registerService(Column.class.getName(), new Column(), null));
        registrationList.add(context.registerService(HtmlPageWidget.class.getName(), new HtmlPageWidget(), null));
        registrationList.add(context.registerService(PageUserviewMenu.class.getName(), new PageUserviewMenu(), null));
    }

    @Override
    public void stop(BundleContext context) {
        for (ServiceRegistration registration : registrationList) {
            registration.unregister();
        }
    }
}