package org.joget.pbuilder.lib;

import java.util.Collection;
import org.joget.apps.app.service.AppPluginUtil;
import org.joget.apps.app.service.AppUtil;
import org.joget.pbuilder.api.PageWidget;
import org.joget.plugin.base.ExtDefaultPlugin;
import org.joget.plugin.property.model.PropertyEditable;

public class Column extends ExtDefaultPlugin implements PageWidget, PropertyEditable {
    
    private final static String MESSAGE_PATH = "messages/PageBuilder";
    
    @Override
    public String getName() {
        return "ColumnWidget";
    }

    @Override
    public String getVersion() {
        return "7.0.0";
    }

    @Override
    public String getDescription() {
        return AppPluginUtil.getMessage("columnWidget.description", getClassName(), MESSAGE_PATH);
    }

    @Override
    public String getIcon() {
        return "";
    }

    @Override
    public String getLabel() {
        return AppPluginUtil.getMessage("columnWidget.label", getClassName(), MESSAGE_PATH);
    }

    @Override
    public String getClassName() {
        return getClass().getName();
    }

    @Override
    public String getPropertyOptions() {
        return AppUtil.readPluginResource(getClassName(), "/properties/page/columnWidget.json", null, true, MESSAGE_PATH);
    }
    
    @Override
    public String render() {
        String cssClass = "";
        String row = getPropertyString("rowDesktopCols");
        if (!getPropertyString("desktopCols").isEmpty()) {
            cssClass += " xl-" + getPropertyString("desktopCols") + "-" + row;
        }
        if (!getPropertyString("tabletCols").isEmpty()) {
            if (!getPropertyString("rowTabletCols").isEmpty()) {
                row = getPropertyString("rowTabletCols");
            }
            cssClass += " md-" + getPropertyString("tabletCols") + "-" + row;
        }
        if (!getPropertyString("mobileCols").isEmpty()) {
            if (!getPropertyString("rowMobileCols").isEmpty()) {
                row = getPropertyString("rowMobileCols");
            }
            cssClass += " sm-" + getPropertyString("mobileCols") + "-" + row;
        }
        
        String html = "<div class=\"col "+cssClass+"\"><div class=\"widgets\">";
        
        //load widgets
        if (getProperty("page_widgets") != null) {
            Collection<PageWidget> childs = (Collection<PageWidget>) getProperty("page_widgets");
            if (!childs.isEmpty()) {
                for (PageWidget c : childs) {
                    html += "<div class=\"widget\">" + c.render() + "</div>";
                }
            }
        }
        
        html += "</div></div>";
        return html;
    }
}