package org.joget.pbuilder.lib;

import java.util.HashMap;
import org.joget.apps.app.dao.BuilderDefinitionDao;
import org.joget.apps.app.model.BuilderDefinition;
import org.joget.apps.app.model.CustomBuilder;
import org.joget.apps.app.service.AppPluginUtil;
import org.joget.apps.app.service.AppUtil;
import org.joget.apps.app.service.CustomBuilderUtil;
import org.joget.apps.userview.model.UserviewMenu;

public class PageUserviewMenu extends UserviewMenu {
     
    private final static String MESSAGE_PATH = "messages/PageBuilder";
  
    public String getName() {
        return "Page Menu";
    }
    public String getVersion() {
        return "7.0.0";
    }
     
    public String getClassName() {
        return getClass().getName();
    }
     
    public String getLabel() {
        //support i18n
        return AppPluginUtil.getMessage("pageMenu.label", getClassName(), MESSAGE_PATH);
    }
     
    public String getDescription() {
        //support i18n
        return AppPluginUtil.getMessage("pageMenu.description", getClassName(), MESSAGE_PATH);
    }
  
    public String getPropertyOptions() {
        return AppUtil.readPluginResource(getClassName(), "/properties/page/pageUserviewMenu.json", null, true, MESSAGE_PATH);
    }
 
    @Override
    public String getCategory() {
        return "Enterprise";
    }
    
    @Override
    public String getIcon() {
        //sorry, i am reuse the icon of other plugin here
        return "<i class=\"fas fa-columns\"></i>";
    }
     
    @Override
    public boolean isHomePageSupported() {
        return true; // Can use as first page of the userview
    }
     
    @Override
    public String getDecoratedMenu() {
        return null; // using default
    }
  
    @Override
    public String getRenderPage() {
        String html = "";
        
        BuilderDefinitionDao builderDefinitionDao = (BuilderDefinitionDao) AppUtil.getApplicationContext().getBean("builderDefinitionDao");
        String id = getPropertyString("pageId");
        BuilderDefinition builderDefinition = builderDefinitionDao.loadById(id, AppUtil.getCurrentAppDefinition());

        if (builderDefinition != null) {
            String json = builderDefinition.getJson();
            CustomBuilder builder = CustomBuilderUtil.getBuilder("page");
            html = (String) builder.getBuilderResult(json, new HashMap<String, Object>());
        }
        
        return html;
    }
}