package org.joget.pbuilder.api;

public interface PageWidget {
    /**
     * Return plugin label. This value will be used when a Resource Bundle 
     * Message Key "<i>plugin.className</i>.pluginlabel" is not found by getI18nLabel() method.
     * 
     * @return
     */
    public String getLabel();

    /**
     * Return Class Name for the plugin.
     * @return
     */
    public String getClassName();

    /**
     * Return the plugin properties options in JSON format.
     * @return
     */
    public String getPropertyOptions();
    
    /**
     * Return the icon to used in palette
     * @return
     */
    public String getIcon();
    
    /**
     * Return the html to render the widget in page
     * @return
     */
    public String render();
}
