package org.joget.pbuilder.lib;

import org.joget.apps.app.service.AppPluginUtil;
import org.joget.apps.app.service.AppUtil;
import org.joget.pbuilder.api.PageWidget;
import org.joget.plugin.base.ExtDefaultPlugin;
import org.joget.plugin.property.model.PropertyEditable;

public class HeadingPageWidget  extends ExtDefaultPlugin implements PageWidget, PropertyEditable {
    
    private final static String MESSAGE_PATH = "messages/HeadingPageWidget";
    
    @Override
    public String getName() {
        return "HeadingPageWidget";
    }

    @Override
    public String getVersion() {
        return "7.0.0";
    }

    @Override
    public String getDescription() {
        return AppPluginUtil.getMessage("headingPageWidget.description", getClassName(), MESSAGE_PATH);
    }

    @Override
    public String getIcon() {
        return "<i class=\"fas fa-heading\"></i>";
    }

    @Override
    public String getLabel() {
        return AppPluginUtil.getMessage("headingPageWidget.label", getClassName(), MESSAGE_PATH);
    }

    @Override
    public String getClassName() {
        return getClass().getName();
    }

    @Override
    public String getPropertyOptions() {
        return AppUtil.readPluginResource(getClassName(), "/properties/page/headingPageWidget.json", null, true, MESSAGE_PATH);
    }
    
    @Override
    public String render() {
        return "<"+getPropertyString("size")+">"+getPropertyString("label")+"</"+getPropertyString("size")+">";
    }
}